# Xapian::MSet Class Reference

A match set (MSet). More...

`#include <enquire.h>`

Collaboration diagram for Xapian::MSet:

[legend]
List of all members.

## Public Types

typedef MSetIterator | value_type
typedef MSetIterator | iterator
typedef MSetIterator | const_iterator
typedef MSetIterator & | reference
typedef MSetIterator & | const_reference
typedef MSetIterator * | pointer
typedef Xapian::doccount_diff | difference_type
typedef Xapian::doccount | size_type

## Public Member Functions

| MSet (MSet::Internal *internal_)
| Constructor for internal use.
| MSet ()
| Create an empty Xapian::MSet.
| ~MSet ()
| Destroy a Xapian::MSet.
| MSet (const MSet &other)
| Copying is allowed (and is cheap).
void | operator= (const MSet &other)
| Assignment is allowed (and is cheap).
void | fetch (const MSetIterator &begin, const MSetIterator &end) const
| Fetch the the document info for a set of items in the MSet.
void | fetch (const MSetIterator &item) const
| Fetch the single item specified.
void | fetch () const
| Fetch all the items in the MSet.
Xapian::percent | convert_to_percent (Xapian::weight wt) const
| This converts the weight supplied to a percentage score.
Xapian::percent | convert_to_percent (const MSetIterator &it) const
| Return the percentage score for a particular item.
Xapian::doccount | get_termfreq (const std::string &tname) const
| Return the term frequency of the given query term.
Xapian::weight | get_termweight (const std::string &tname) const
| Return the term weight of the given query term.
Xapian::doccount | get_firstitem () const
| The index of the first item in the result which was put into the MSet.
Xapian::doccount | get_matches_lower_bound () const
| A lower bound on the number of documents in the database which match the query.
Xapian::doccount | get_matches_estimated () const
| An estimate for the number of documents in the database which match the query.
Xapian::doccount | get_matches_upper_bound () const
| An upper bound on the number of documents in the database which match the query.
Xapian::weight | get_max_possible () const
| The maximum possible weight in the mset.
Xapian::weight | get_max_attained () const
| The greatest weight which is attained by any document in the database.
Xapian::doccount | size () const
| The number of items in this MSet.
Xapian::doccount | max_size () const
| Required to allow use as an STL container.
bool | empty () const
| Test if this MSet is empty.
void | swap (MSet &other)
| Swap the MSet we point to with another.
MSetIterator | begin () const
| Iterator for the terms in this MSet.
MSetIterator | end () const
| End iterator corresponding to begin().
MSetIterator | back () const
| Iterator pointing to the last element of this MSet.
MSetIterator | operator[] (Xapian::doccount i) const
| This returns the document at position i in this MSet object.
std::string | get_description () const
| Returns a string representing the mset.

## Public Attributes

Xapian::Internal::RefCntPtr< Internal > | internal
| Reference counted internals.

## Detailed Description

A match set (MSet).

This class represents (a portion of) the results of a query.

## Constructor & Destructor Documentation

Xapian::MSet::MSet | ( | MSet::Internal * | internal_ | ) | `[explicit]`

| Constructor for internal use.

Xapian::MSet::MSet | ( |  | ) |

| Create an empty Xapian::MSet.

Xapian::MSet::~MSet | ( |  | ) |

| Destroy a Xapian::MSet.

Xapian::MSet::MSet | ( | const MSet & | other | ) |

| Copying is allowed (and is cheap).

## Member Function Documentation

MSetIterator Xapian::MSet::back | ( |  | ) | const

| Iterator pointing to the last element of this MSet.

MSetIterator Xapian::MSet::begin | ( |  | ) | const

| Iterator for the terms in this MSet.

Xapian::percent Xapian::MSet::convert_to_percent | ( | const MSetIterator & | it | ) | const

| Return the percentage score for a particular item.

Xapian::percent Xapian::MSet::convert_to_percent | ( | Xapian::weight | wt | ) | const

| This converts the weight supplied to a percentage score. The return value will be in the range 0 to 100, and will be 0 if and only if the item did not match the query at all.

bool Xapian::MSet::empty | ( |  | ) | const

| Test if this MSet is empty.

MSetIterator Xapian::MSet::end | ( |  | ) | const

| End iterator corresponding to begin().

void Xapian::MSet::fetch | ( |  | ) | const

| Fetch all the items in the MSet.

void Xapian::MSet::fetch | ( | const MSetIterator & | item | ) | const

| Fetch the single item specified.

void Xapian::MSet::fetch | ( | const MSetIterator & | begin,
|  | const MSetIterator & | end
| ) | const

Fetch the the document info for a set of items in the MSet.

This method causes the documents in the range specified by the iterators to be fetched from the database, and cached in the Xapian::MSet object. This has little effect when performing a search across a local database, but will greatly speed up subsequent access to the document contents when the documents are stored in a remote database.

The iterators must be over this Xapian::MSet: undefined behaviour will result otherwise.

Parameters:

  | begin | MSetIterator for first item to fetch.
  | end | MSetIterator for item after last item to fetch.

std::string Xapian::MSet::get_description | ( |  | ) | const

| Returns a string representing the mset. Introspection method.

Xapian::doccount Xapian::MSet::get_firstitem | ( |  | ) | const

| The index of the first item in the result which was put into the MSet. This corresponds to the parameter "first" specified in Xapian::Enquire::get_mset(). A value of 0 corresponds to the highest result being the first item in the mset.

Xapian::doccount Xapian::MSet::get_matches_estimated | ( |  | ) | const

An estimate for the number of documents in the database which match the query.

This figure takes into account collapsing of duplicates, and weighting cutoff values.

This value is returned because there is sometimes a request to display such information. However, our experience is that presenting this value to users causes them to worry about the large number of results, rather than how useful those at the top of the result set are, and is thus undesirable.

Xapian::doccount Xapian::MSet::get_matches_lower_bound | ( |  | ) | const

| A lower bound on the number of documents in the database which match the query. This figure takes into account collapsing of duplicates, and weighting cutoff values. This number is usually considerably less than the actual number of documents which match the query.

Xapian::doccount Xapian::MSet::get_matches_upper_bound | ( |  | ) | const

| An upper bound on the number of documents in the database which match the query. This figure takes into account collapsing of duplicates, and weighting cutoff values. This number is usually considerably greater than the actual number of documents which match the query.

Xapian::weight Xapian::MSet::get_max_attained | ( |  | ) | const

The greatest weight which is attained by any document in the database.

If firstitem == 0, this is the weight of the first entry in items.

If no documents are found by the query, this will be 0.

Note that calculation of max_attained requires calculation of at least one result item - therefore, if no items were requested when the query was performed (by specifying maxitems = 0 in Xapian::Enquire::get_mset()), this value will be 0.

Xapian::weight Xapian::MSet::get_max_possible | ( |  | ) | const

| The maximum possible weight in the mset. This weight is likely not to be attained in the set of results, but represents an upper bound on the weight which a document could attain for the given query.

Xapian::doccount Xapian::MSet::get_termfreq | ( | const std::string & | tname | ) | const

Return the term frequency of the given query term.

Parameters:

  | tname | The term to look for.

Exceptions:

  | Xapian::InvalidArgumentError | is thrown if the term was not in the query.

Xapian::weight Xapian::MSet::get_termweight | ( | const std::string & | tname | ) | const

Return the term weight of the given query term.

Parameters:

  | tname | The term to look for.

Exceptions:

  | Xapian::InvalidArgumentError | is thrown if the term was not in the query.

Xapian::doccount Xapian::MSet::max_size | ( |  | ) | const`[inline]`

| Required to allow use as an STL container.

void Xapian::MSet::operator= | ( | const MSet & | other | ) |

| Assignment is allowed (and is cheap).

MSetIterator Xapian::MSet::operator[] | ( | Xapian::doccount | i | ) | const

| This returns the document at position i in this MSet object. Note that this is not the same as the document at rank i in the query, unless the "first" parameter to Xapian::Enquire::get_mset was 0. Rather, it is the document at rank i + first. In other words, the offset is into the documents represented by this object, not into the set of documents matching the query.

Xapian::doccount Xapian::MSet::size | ( |  | ) | const

| The number of items in this MSet.

void Xapian::MSet::swap | ( | MSet & | other | ) |

| Swap the MSet we point to with another.

## Member Data Documentation

Xapian::Internal::RefCntPtr<Internal> Xapian::MSet::internal

| Reference counted internals.

The documentation for this class was generated from the following file:

- include/xapian/enquire.h